declare global {
    interface Function {
        /** The original function, before any binding. */
        unbounded?: this;
    }
}
/**
 * Alternative to `Function.prototype.bind` that sets the `unbounded` property on the bounded function.
 * Types of this are not intelligent, as using the intelligent bind types causes this/unknown incompatibility. This is not important however, as the masquerading binder of {@link patch} has the intelligent types.
 */
export declare function binder(this: Function, thisArg: any, ...argArray: any[]): any;
/** Patch the native `Function.prototype.bind` so that it sets the `unbounded` property on the bounded function. */
export declare function patch(): void;
//# sourceMappingURL=index.d.ts.map